;--- DESS IRR03 --- Le 10/01/2003 ---
; Alexandre ALAPETITE et Pierre COHADE
;
; Nom du fichier:
;    "NOYAU_FC.lisp".
;
; Rle du fichier:
;    Ce fichier contient les fonctions du Programme du FC.
;

;Dclaration de la liste des contraintes du Filtre Check Forward
(DEFVAR LISTE_CONTRAINTES_FCF 'LISTE_CONTRAINTES_FCF)

;Dclaration de notre pile
(defparameter *pile* '())

;Variable qui nous sert  vider notre pile
(DEFVAR purge NIL)

;Variable globale servant  savoir si l'on a trouve une solution pour le FC
(DEFVAR Solution_trouvee_fc NIL)


;Fonction Check Forward
(DEFUN CHECK_FORWARD(LX nomX)
  (LET ((consistant T))
    (loop for contrainte in (GET_VARIABLE LISTE_CONTRAINTES_FCF nomX) do
      (loop for var in (LISTE_VAR_CONTRAINTE_NO_NOMX contrainte nomX) do
        (IF (EQUAL consistant T)
          (do ((fin_boucle_cf NIL))
              ((OR (EQUAL fin_boucle_cf T) (NULL consistant)))
            (IF (NULL (EVAL contrainte))
              (IF (NULL (INC_VALEUR_AND_DEL LX var))
                (IF (NULL (SET_FIRST_VALEUR LX var))
                  (SETF consistant NIL)
                )
              )
              (IF (NULL (INC_VALEUR LX var))
                (PROGN
                  (SET_FIRST_VALEUR LX var)
                  (SETF fin_boucle_cf T)
                )
              )
            )
          )
        )
      )
    )
    consistant
  )
)

;Programme FC
(DEFUN R_PROG_FC(LX liste_variables)
  (IF (NULL liste_variables)
    (SETF Solution_trouvee_fc T)
    (do ((fin_boucle NIL))
        ((OR (EQUAL fin_boucle T) (EQUAL Solution_trouvee_fc T)))
      (loop for var in (REST liste_variables) do
        (PUSH (COPY_PLISTE (GET_DOMAINE LX var)) *pile*)
      )
      (IF (EQUAL (CHECK_FORWARD LX (FIRST liste_variables)) T)
        (R_PROG_FC LX (REST liste_variables))
      )
      (IF (NULL Solution_trouvee_fc)
        (PROGN
          (loop for var in (REVERSE (REST liste_variables)) do
            (SET_DOMAINE LX var (POP *pile*))
            (SET_FIRST_VALEUR LX var)
          )
          (IF (NULL (INC_VALEUR LX (FIRST liste_variables)))
            (PROGN
              (SET_FIRST_VALEUR LX (FIRST liste_variables))
              (SETF fin_boucle T)
            )
          )
        )
        (loop for var in (REVERSE (REST liste_variables)) do
          (SETF purge (POP *pile*))
        )
      )
    )
  )
)

;Fonction servant  initialiser et  lancer le programme FC
(DEFUN PROG_FC(LX)
  (PROGN
    (SETF Solution_trouvee_fc NIL)
    (R_PROG_FC LX (LISTE_VARIABLES LX))
    Solution_trouvee_fc
  )
)
