;--- DESS IRR03 --- Le 05/01/2003 ---
; Alexandre ALAPETITE et Pierre COHADE
;
; Nom du fichier:
;    "TRAITEMENT_PLISTE.lisp".
;
; Rle du fichier:
;    Ce fichier contient les fonctions qui crent et qui traitent la PLISTE "VARIABLES".
;

;cherche la valeur suivant e dans la liste liste
(DEFUN SUIVANT(liste e)
 (IF (NULL liste)
   NIL
   (IF (EQUAL e (FIRST liste))
     (CADR liste)
     (SUIVANT (REST liste) e)
   )
 )
)

;retourne le premier lment de liste gal  e1 ou e2 sinon NIL
;utilis pour l'ordre total entre les variables
(DEFUN CHERCHE2(liste e1 e2)
  (IF (NULL liste)
    NIL
    (IF (EQUAL (FIRST liste) e1)
      e1
      (IF (EQUAL (FIRST liste) e2)
        e2
        (CHERCHE2 (REST liste) e1 e2)
      )
    )
  )
)

;renvoi True si la variable var se trouve dans la pliste sinon NIL
(DEFUN IS_VAR_EXISTE(pliste var)
  (IF (NULL pliste)
    NIL
    (IF (EQUAL (FIRST pliste) var)
       T
       (IS_VAR_EXISTE (REST pliste) var)
    )
  )
)

;retourne une liste de variables qui ne sont pas encore dans la pliste LX
(DEFUN CHERCHE_VAR_NO_PLISTE(pliste liste_var)
  (IF (NULL liste_var)
    NIL
    (IF (NULL (IS_VAR_EXISTE pliste (FIRST liste_var)))
      (NCONC (LIST (FIRST liste_var)) (CHERCHE_VAR_NO_PLISTE pliste (REST liste_var)))
      (CHERCHE_VAR_NO_PLISTE pliste (REST liste_var))
    )
  )
)

;renvoie une liste de variables ne contenant pas de variable en double
(DEFUN DEL_DOUBLE_VAR_LISTE(liste)
  (IF (NOT (NULL liste))
    (IF (NULL (MEMBER (FIRST liste) (REST liste)))
      (CONS (FIRST liste) (DEL_DOUBLE_VAR_LISTE (REST liste)))
      (DEL_DOUBLE_VAR_LISTE (REST liste))
    )
  )
)

;sous_fonction qui renvoie la plus grande variable de la liste de variable
(DEFUN _GET_PGRANDE_CONTRAINTE_LISTE(pliste listeVariable Pgrand)
  (IF (NULL listeVariable)
    Pgrand
    (PROGN
      (IF (EQUAL (CHERCHE2 pliste Pgrand (FIRST listeVariable)) Pgrand)
        (SETF Pgrand (CAR listeVariable))
      )
      (_GET_PGRANDE_CONTRAINTE_LISTE pliste (REST listeVariable) Pgrand)
    )
  )
)

;retourne la plus grande variable de la listeVariable (liste des variables de la contrainte)
;utilis pour savoir  quelle variable sera attache la contrainte
(DEFUN GET_PGRANDE_CONTRAINTE_LISTE(LX listeVariable)
  (_GET_PGRANDE_CONTRAINTE_LISTE (SYMBOL-PLIST LX) (REST listeVariable) (FIRST listeVariable))
)

;sous-fonction qui renvoie la plus petite variable de la liste de variables
(DEFUN _GET_PPETITE_CONTRAINTE_LISTE(pliste listeVariable Ppetit)
  (IF (NULL listeVariable)
    Ppetit
    (PROGN
      (IF (NOT (EQUAL (CHERCHE2 pliste Ppetit (FIRST listeVariable)) Ppetit))
        (SETF Ppetit (CAR listeVariable))
      )
      (_GET_PPETITE_CONTRAINTE_LISTE pliste (REST listeVariable) Ppetit)
    )
  )
)

;retourne la plus petite variable de la listeVariable (liste des variables de la contrainte)
;utilis (pour le filtre Check Forward) pour savoir  quelle variable sera attache la contrainte
(DEFUN GET_PPETITE_CONTRAINTE_LISTE(LX listeVariable)
  (_GET_PPETITE_CONTRAINTE_LISTE (SYMBOL-PLIST LX) (REST listeVariable) (FIRST listeVariable))
)

;ajoute une contrainte  la variable X
(DEFMACRO ADD_CONTRAINTE(X contrainte)
  `(PROGN
     (IF (NULL ,X)
       (SETQ ,X (LIST ,contrainte))
       (SETQ ,X (NCONC ,X (LIST ,contrainte)))
     )
     ,contrainte
   )
)

;retourne la valeur de la variable X
(DEFUN GET_VALEUR(X)
  (FIRST X)
)

;change la valeur de la variable X par valeur
;pas de vrification que valeur est valide dans le domaine de X
(DEFUN SET_VALEUR(nomX X valeur)
  (PROGN
    (SETF (FIRST X) valeur)
    (SET nomX (EVAL valeur))
  )
)

;Initialise la variable nomX  la premire valeur de son domaine
(DEFUN SET_FIRST_VALEUR(LX nomX)
  (SET_VALEUR nomX (GET_VARIABLE LX nomX) (CAADR (GET_VARIABLE LX nomX)))
)

;Initialise les variables de contrainte  la premire valeur de leur domaine sauf nomX
(DEFUN SET_FIRST_VALEUR_LISTE(LX contrainte nomX)
  (loop for var in (LISTE_VAR_CONTRAINTE_NO_NOMX contrainte nomX) do
    (SET_FIRST_VALEUR LX var)
  )
)

;change la valeur de la variable X par la valeur suivante dans son domaine de valeurs
(DEFUN INC_VALEUR(LX nomX)
  (SET_VALEUR nomX (GET_VARIABLE LX nomX) (SUIVANT (CADR (GET_VARIABLE LX nomX)) (GET_VALEUR (GET_VARIABLE LX nomX))))
)

;change la valeur d'une liste de variable par la valeur suivante dans son domaine de valeurs
(DEFUN _INC_VALEUR_LISTE(LX liste)
  (IF (NULL liste)
    NIL
    (IF (NOT (NULL (SUIVANT (CADR (GET_VARIABLE LX (FIRST liste))) (GET_VALEUR (GET_VARIABLE LX (FIRST liste))))))
      (INC_VALEUR LX (FIRST liste))
      (PROGN
        (SET_FIRST_VALEUR LX (FIRST liste))
        (_INC_VALEUR_LISTE LX (REST liste))
      )
    )
  )
)

;change la valeur d'une liste de variables par la valeur suivante dans son domaine de valeurs
(DEFUN INC_VALEUR_LISTE(LX contrainte nomX)
  (_INC_VALEUR_LISTE LX (LISTE_VAR_CONTRAINTE_NO_NOMX contrainte nomX))
)

;change la valeur de la variable X par la valeur suivante dans son domaine de valeurs
;et dtruit la valeur prcdente du domaine
(DEFUN INC_VALEUR_AND_DEL(LX nomX)
  (PROGN
    (LET ((val (GET_VALEUR (GET_VARIABLE LX nomX))))
      (INC_VALEUR LX nomX)
      (SET_DOMAINE LX nomX (DELETE val (CADR (GET_VARIABLE LX nomX))))
    )
    (GET_VALEUR (GET_VARIABLE LX nomX))
  )
)

;retourne la variable de nom nomX dans la liste LX
(DEFUN GET_VARIABLE(LX nomX)
  (GET LX nomX)
)

;ajoute une variable X de nom nomX  la liste LX
(DEFUN SET_VARIABLE(LX nomX X)
  (SETF (GET LX nomX) X)
)

;retourne vrai si nomX est avant nomY dans LX faux sinon
(DEFUN IS_PPETIT(LX nomX nomY)
  (IF (EQUAL (CHERCHE2 (SYMBOL-PLIST LX) nomX nomY) nomX)
    T
    NIL
  )
)

;Cre la variable X dans la liste LX (la valeur de la variable et son domaine sont initialiss  NIL)
(DEFUN CREER_VARIABLE(LX nomX)
  (LET ((VAR_LOC nomX)) (SET_VARIABLE LX VAR_LOC (NCONC (LIST '()) (LIST '(NIL)))))
)

;les N variables se trouvant dans liste_var sont cres dans la liste LX
;(la valeur de la variable et son domaine sont initialiss  NIL)
(DEFUN CREER_N_VARIABLES(LX liste_var)
  (IF (NULL liste_var)
    NIL
    (PROGN
      (CREER_VARIABLE LX (FIRST liste_var))
      (CREER_N_VARIABLES LX (REST liste_var))
    )
  )
)

;retourne une liste du domaine de nomX de la liste LX
(DEFUN GET_DOMAINE(LX nomX)
  (CADR (GET_VARIABLE LX nomX))
)

;Cette fonction nous permet d'initialiser la valeur du domaine de la variable nomX
;de la PListe LX avec la valeur Domaine
(DEFUN SET_DOMAINE(LX nomX Domaine)
  (PROGN
    (IF (NULL (GET LX nomX))
      (CREER_VARIABLE LX nomX)
    )
    (SETF (CADR (GET_VARIABLE LX nomX)) Domaine)
    (SET_FIRST_VALEUR LX nomX)
  )
)

;retourne la liste complte de toutes les variables se trouvant dans la contrainte
;(elle ne fait pas le tri des variables en double)
(DEFUN _LISTE_VAR_CONTRAINTE(contrainte)
  (LET ((VAR_LOC NIL))
    (PROGN
      (IF (LISTP (CADR contrainte))
        (SETF VAR_LOC (NCONC VAR_LOC (_LISTE_VAR_CONTRAINTE (CADR contrainte))))
        (IF (NOT (NUMBERP (CADR contrainte)))
          (SETF VAR_LOC (NCONC VAR_LOC (LIST (CADR contrainte))))
        )
      )
      (IF (LISTP (CADDR contrainte))
        (SETF VAR_LOC (NCONC VAR_LOC (_LISTE_VAR_CONTRAINTE (CADDR contrainte))))
        (IF (NOT (NUMBERP (CADDR contrainte)))
          (SETF VAR_LOC (NCONC VAR_LOC (LIST (CADDR contrainte))))
        )
      )
    )
    VAR_LOC
  )
)

;renvoie la liste des variables se trouvant dans la contrainte
(DEFUN LISTE_VAR_CONTRAINTE(contrainte)
  (DEL_DOUBLE_VAR_LISTE (_LISTE_VAR_CONTRAINTE contrainte))
)

;renvoie la liste des variables se trouvant dans la contrainte sans nomX
(DEFUN LISTE_VAR_CONTRAINTE_NO_NOMX(contrainte nomX)
  (DELETE nomX (LISTE_VAR_CONTRAINTE contrainte))
)

;retourne la liste des variables contenues dans les contraintes de la variable nomX
(DEFUN _VARIABLES_LIEES(L nomX)
  (IF (NULL L)
    NIL
    (NCONC (_LISTE_VAR_CONTRAINTE (FIRST L)) (_VARIABLES_LIEES (REST L) nomX))
  )
)

;retourne la liste des variables contenues dans les contraintes de la variable nomX
;sans doublons, et sans nomX
(DEFUN VARIABLES_LIEES(LX nomX)
  (DELETE nomX (DEL_DOUBLE_VAR_LISTE (_VARIABLES_LIEES (LISTE_CONTRAINTES LX nomX) nomX)))
)

;ajoute automatiquement une contrainte
(DEFUN AJOUT_CONTRAINTE(LX contrainte)
  (PROGN
    (CREER_N_VARIABLES LX (CHERCHE_VAR_NO_PLISTE (SYMBOL-PLIST LX) (LISTE_VAR_CONTRAINTE contrainte)))
    (LET ((VAR_LOC (GET_VARIABLE LX (GET_PGRANDE_CONTRAINTE_LISTE LX (LISTE_VAR_CONTRAINTE contrainte))))) (ADD_CONTRAINTE VAR_LOC contrainte))
  )
)

;retourne la liste de contrainte de la variable X de la liste LX
(DEFUN LISTE_CONTRAINTES(LX X)
  (CDDR (GET LX X))
)

;parcourt la liste de contrainte en les valuants, renvoi NIL ds qu'une contrainte est NIL
(DEFUN EVAL_LISTE_CONTRAINTES(liste_contrainte)
  (COND
    ((NULL liste_contrainte) T)
    ((NULL (EVAL (FIRST liste_contrainte))) NIL)
    (T (EVAL_LISTE_CONTRAINTES (REST liste_contrainte)))
  )
)

;renvoi T si toutes les contraintes de la variable X de la liste LX sont T sinon NIL
(DEFUN EVAL_ALL_CONTRAINTES(LX X)
  (IF (NULL (LISTE_CONTRAINTES LX X))
    T
    (EVAL_LISTE_CONTRAINTES (LISTE_CONTRAINTES LX X))
  )
)

;
(DEFUN VARIABLE_SUIVANTE(liste)
  (IF (NULL (CDDR liste))
    (LIST (FIRST liste))
    (NCONC (LIST (FIRST liste)) (VARIABLE_SUIVANTE (CDDR liste)))
  )
)

;retourne la liste des variables de la liste LX
(DEFUN LISTE_VARIABLES(LX)
  (VARIABLE_SUIVANTE (SYMBOL-PLIST LX))
)

;fonction rcursive qui parcourt la liste de variables en vrifiant si elles ont un domaine
(DEFUN _LISTE_VARIABLES_NO_DOMAINE(LX Liste)
  (IF (NULL (REST Liste))
    (IF (EQUAL (FIRST (GET_VARIABLE LX (FIRST liste))) NIL)
       (LIST (FIRST liste))
    )
    (IF (EQUAL (FIRST (GET_VARIABLE LX (FIRST liste))) NIL)
       (NCONC (LIST (FIRST liste)) (_LISTE_VARIABLES_NO_DOMAINE LX (REST liste)))
       (_LISTE_VARIABLES_NO_DOMAINE LX (REST liste))
    )
  )
)

;retourne une liste de variables si on ne leur a pas attribu de domaine
;sinon elle retourne NIL si toute les variables ont un domaine.
(DEFUN LISTE_VARIABLES_NO_DOMAINE(LX)
  (_LISTE_VARIABLES_NO_DOMAINE LX (LISTE_VARIABLES LX))
)

;Cette fonction sert  initialiser la liste LISTE_CONTRAINTES_FCF pour le filtre Check Forward
(DEFUN CREER_LISTE_CHECK_FORWARD(LX)
  (PROGN
    (RAZ LISTE_CONTRAINTES_FCF)
    (SETF (SYMBOL-PLIST LISTE_CONTRAINTES_FCF) (COPY_PLISTE (SYMBOL-PLIST LX)))
    (loop for var in (LISTE_VARIABLES LISTE_CONTRAINTES_FCF) do
     (SET_VARIABLE LISTE_CONTRAINTES_FCF var '())
     (loop for contrainte in (COPY_PLISTE (LISTE_CONTRAINTES LX var)) do
        (LET ((VAR_LOC (GET_PPETITE_CONTRAINTE_LISTE LISTE_CONTRAINTES_FCF (LISTE_VAR_CONTRAINTE contrainte))))
          (SET_VARIABLE LISTE_CONTRAINTES_FCF VAR_LOC (NCONC (GET_VARIABLE LISTE_CONTRAINTES_FCF VAR_LOC) (LIST contrainte)))
        )
      )
    )
  )
)

;cette fonction retourne la copie de la pliste LX.
(DEFUN COPY_PLISTE(LX)
  (IF (ATOM LX)
    (IF (NULL LX)
      ()
      (FIRST (COPY-LIST (LIST LX)))
    )
    (append (LIST (COPY_PLISTE (FIRST LX))) (COPY_PLISTE (REST LX)))
  )
)

;cette fonction sert  rinitialiser la liste LX lors d'un deuxime appel de celle-ci.
(DEFUN RAZ(LX)
  (IF (NULL (SYMBOL-PLIST LX))
    NIL
    (PROGN
      (REMPROP LX (FIRST (SYMBOL-PLIST LX)))
      (RAZ LX)
    )
  )
)

;Cette fonction recopie la PListe LX2 dans la PListe LX1 et initialise celle-ci
(DEFUN RECOPIE_PLISTE(LX1 LX2)
  (PROGN
    (RAZ LX1)
    (SETF (SYMBOL-PLIST LX1) (COPY_PLISTE (SYMBOL-PLIST LX2)))
    (INIT_PLISTE LX1)
  )
)

; Cette fonction initialise les valeurs des variables de la PListe LX
(DEFUN INIT_PLISTE(LX)
  (IF (NOT (NULL (SYMBOL-PLIST LX)))
    (loop for var in (LISTE_VARIABLES LX) do
      (SET_FIRST_VALEUR LX var)
    )
  )
)

;Cration de la PLISTE "VARIABLES".
(DEFVAR VARIABLES 'VARIABLES)
(RAZ VARIABLES)
